
#ifndef _ECC_SAFEENGINE_H
#define _ECC_SAFEENGINE_H

//Error code definition
#define	SE_SUCCESS                              0L

#define	SE_ECC_ERROR_READ_FILE                                  0x82050000
#define	SE_ECC_ERROR_UNKNOWN_KEY_FORMAT_OR_WRONG_PASSWORD       0x82050001
#define	SE_ECC_ERROR_INVALID_HANDLE                             0x82050002
#define	SE_ECC_ERROR_NO_KEY                                     0x82050003
#define	SE_ECC_ERROR_MATCH_KEY_AND_ALG                          0x82050004
#define	SE_ECC_ERROR_INVALID_ALG                                0x82050005
#define	SE_ECC_ERROR_SIGN                                       0x82050006
#define	SE_ECC_ERROR_DIGEST                                     0x82050007
#define	SE_ECC_ERROR_NO_ENOUGH_MEMORY                           0x82050008
#define	SE_ECC_ERROR_INVALID_CERT                               0x82050009
#define SE_ECC_ERROR_NO_PUBKEY                                  0x8205000A
#define	SE_ECC_ERROR_VERIFY_SIGN                                0x8205000B
#define	SE_ECC_ERROR_GEN_KEYPAIR                                0x8205000C
#define	SE_ECC_ERROR_ENCODE_P12                                 0x8205000D
#define	SE_ECC_ERROR_INVALID_P12                                0x8205000E
#define	SE_ECC_ERROR_DECODE_P12                                 0x8205000F
#define	SE_ECC_ERROR_LOAD_BUILTIN_EC                            0x82050010
#define	SE_ECC_ERROR_MATCH_KEYPAIR                              0x82050011
#define SE_ECC_ERROR_ENCODE_PKCS10                              0x82050012
#define SE_ECC_ERROR_DECODE_PKCS10                              0x82050013
#define SE_ECC_ERROR_INVALID_PUBKEY                             0x82050014
#define SE_ECC_ERROR_INVALID_PKCS10                             0x82050015
#define SE_ECC_ERROR_VERIFY_PKCS10                              0x82050016
#define	SE_ECC_ERROR_INVALID_KEY                                0x82050017
#define SE_ECC_ERROR_DECODE_PUBKEY                              0x82050018
#define	SE_ECC_ERROR_INVALID_SIGN                               0x82050019
#define	SE_ECC_ERROR_INVALID_EC                                 0x8205001A
#define SE_ECC_ERROR_DECODE_KEY                                 0x8205001B
#define	SE_ECC_ERROR_WRITE_FILE                                 0x8205001C
#define	SE_ECC_ERROR_INVALID_SPC                                0x8205001D
#define SE_ECC_ERROR_MEMORY										0x8205001E
#define SE_ECC_ERROR_INITIAL_SESSION							0x8205001F
#define SE_ECC_ERROR_READ_CONFIG								0x82050020
#define SE_ECC_ERROR_OPEN_DEVICE								0x82050021
#define SE_ECC_ERROR_OPEN_SESSION								0x82050022
#define SE_ECC_ERROR_LOAD_LIBRARY								0x82050023
#define SE_ECC_ERROR_DEVICE_TYPE								0x82050024
#define SE_ECC_ERROR_ALG_NOT_SUPPORT							0x82050025
#define SE_ECC_ERROR_GEN_PKCS10									0x82050026
#define SE_ECC_ERROR_EXPORT_PUBKEY								0x82050027
#define	SE_ECC_ERROR_INVALID_POINT								0x82050028
#define	SE_ECC_ERROR_ENCRYPT									0x82050029
#define	SE_ECC_ERROR_DECRYPT									0x8205002A
#define SE_ECC_ERROR_PEM_DECODE									0x8205002B
#define SE_ECC_ERROR_GET_CERT_DETAIL							0x8205002C
#define SE_ECC_ERROR_PEM_ENCODE									0x8205002D
#define SE_ECC_ERROR_GET_CERT_EXTENSION							0x8205002E
#define SE_ECC_ERROR_INVALID_INTERFACE_TYPE						0x8205002F
#define SE_ECC_ERROR_INVALID_PARAMETER							0x82050030
#define SE_ECC_ERROR_ENUM_DEVICE								0x82050031
#define SE_ECC_ERROR_NO_SUCH_DEVICE								0x82050032
#define SE_ECC_ERROR_CONNECT_DEVICE								0x82050033
#define SE_ECC_ERROR_SKF_GEN_RANDOM								0x82050034
#define SE_ECC_ERROR_SKF_SET_SYMKEY								0x82050035
#define SE_ECC_ERROR_SKF_ENCRYPT_INIT							0x82050036
#define SE_ECC_ERROR_SKF_ENCRYPT								0x82050037
#define SE_ECC_ERROR_SKF_DEV_AUTH								0x82050038
#define SE_ECC_ERROR_SKF_OPEN_APP								0x82050039
#define SE_ECC_ERROR_SKF_DEVICE_LOCK							0x8205003A
#define SE_ECC_ERROR_SKF_WRONG_PIN								0x8205003B
#define SE_ECC_ERROR_SKF_ENUM_APP								0x8205003C
#define SE_ECC_ERROR_SKF_DELETE_APP								0x8205003D
#define SE_ECC_ERROR_SKF_CREATE_APP								0x8205003E
#define SE_ECC_ERROR_SKF_CREATE_CONTAINER						0x8205003F
#define SE_ECC_ERROR_DEVICE_OPERATION_NOT_SUPPORT				0x82050040
#define SE_ECC_ERROR_SKF_OPEN_CONTAINER							0x82050041
#define SE_ECC_ERROR_SKF_EXPORT_PUBKEY							0x82050042
#define SE_ECC_ERROR_SKF_ECC_ENCRYPT							0x82050046
#define SE_ECC_ERROR_SKF_IMPORT_ECC_KEYPAIR						0x82050047
#define SE_ECC_ERROR_SKF_CHANGE_DEV_PIN							0x82050048
#define SE_ECC_ERROR_SKF_IMPORT_CERT							0x82050049
#define SE_ECC_ERROR_SKF_EXPORT_CERT							0x8205004A
#define SE_ECC_ERROR_SKF_CREATE_FILE							0x8205004B
#define SE_ECC_ERROR_SKF_WRITE_FILE								0x8205004C
#define SE_ECC_ERROR_SKF_GET_FILE_INFO							0x8205004D
#define SE_ECC_ERROR_SKF_READ_FILE								0x8205004E
#define SE_ECC_ERROR_SKF_GET_PUBKEY								0x8205004F
#define	SE_ECC_ERROR_SKF_GEN_KEYPAIR							0x82050052
#define	SE_ECC_ERROR_CERT_EXPIRED								0x82050053
#define	SE_ECC_ERROR_MORE_THAN_ONE_DEVICE						0x82050054
#define	SE_ECC_ERROR_NO_DEVICE									0x82050055
#define	SE_ECC_ERROR_AUTO_DETECT_DEVICE							0x82050056
#define	SE_ECC_ERROR_DEV_UNRECOGNIZE							0x82050057
#define	SE_ECC_ERROR_SDF_GEN_SESSION_KEY						0x82050058
#define	SE_ECC_ERROR_SDF_IMPORT_SESSION_KEY						0x82050059
#define	SE_ECC_ERROR_SKF_DIGEST_INIT							0x8205005A
#define	SE_ECC_ERROR_SKF_DIGEST_UPDATE							0x8205005B
#define	SE_ECC_ERROR_SKF_GEN_SESSION_KEY						0x8205005C
//#define	SE_ECC_ERROR_SDF_GEN_SESSION_KEY						0x8205005D
#define	SE_ECC_ERROR_SKF_IMPORT_SESSION_KEY						0x8205005E
#define	SE_ECC_ERROR_BUF_OVERFLOW								0x8205005F
#define	SE_ECC_ERROR_P7_SIGNDATA_INIT							0x82050060
#define SE_ECC_ERROR_SDF_GEN_RANDOM								0x82050061
#define SE_ECC_ERROR_SDF_SYM_ENCRYPT							0x82050062
#define SE_ECC_ERROR_SDF_SYM_DECRYPT							0x82050063
#define SE_ECC_ERROR_SDF_EXPORT_PUBKEY							0x82050064
#define SE_ECC_ERROR_ADD_P7_ALG									0x82050065
#define SE_ECC_ERROR_ADD_P7_SIGNATURE							0x82050065
#define	SE_ECC_ERROR_P7_DATA_FINAL								0x82050066
#define	SE_ECC_ERROR_ENVELOPE_ADD_RECIP							0x82050067
#define	SE_ECC_ERROR_SKF_SIGN_DATA								0x82050068
#define	SE_ECC_ERROR_SKF_DIGEST_FINAL							0x82050069
#define	SE_ECC_ERROR_SKF_ENCRYPT_UPDATE							0x8205006A
#define	SE_ECC_ERROR_SKF_ENCRYPT_FINAL							0x8205006B
#define	SE_ECC_ERROR_SKF_DECRYPT_INIT							0x8205006C
#define	SE_ECC_ERROR_SKF_DECRYPT_UPDATE							0x8205006D
#define	SE_ECC_ERROR_SKF_DECRYPT_FINAL							0x8205006E
#define	SE_ECC_ERROR_INVALID_P7									0x8205006F
#define	SE_ECC_ERROR_P7_NO_RECIP								0x82050070
#define	SE_ECC_ERROR_INVALID_SYM_ALG							0x82050071
#define	SE_ECC_ERROR_INVALID_KEY_LEN							0x82050072
#define	SE_ECC_ERROR_P7_GET_SIGNER								0x82050073
#define	SE_ECC_ERROR_P7_SIGNDATA_VERIFY							0x82050074
#define	SE_ECC_ERROR_SIGN_P7_FAIL_SET_ISSUER					0x82050075
#define	SE_ECC_ERROR_SKF_LOCK_DEVICE							0x82050076
#define	SE_ECC_ERROR_NO_ENOUGH_BUFFER							0x82050077
#define	SE_ECC_ERROR_GET_CERT_FROM_LDAP							0x82050078
#define	SE_ECC_ERROR_CONNECT_OCSP								0x82050079
#define	SE_ECC_ERROR_PARAM										0x8205007A
#define	SE_ECC_ERROR_INVALID_CRL								0x8205007B
#define	SE_ECC_ERROR_CERT_REVOKED								0x8205007C
#define	SE_ECC_ERROR_INVALID_CERT_CHAIN							0x8205007D
#define	SE_ECC_ERROR_VERIFY_CERT_CHAIN							0x8205007E
#define SE_ECC_ERROR_SKF_WRONG_ADMIN_PIN						0x8205007F
#define SE_ECC_ERROR_INVALID_DEV_TAG							0x82050080
#define SE_ECC_ERROR_SKF_DELETE_CONTAINER						0x82050081
#define SE_ECC_ERROR_SKF_ENUM_FILE								0x82050082
#define SE_ECC_ERROR_SKF_DELETE_FILE							0x82050083
#define SE_ECC_ERROR_SKF_ENUM_CONTAINER                         0x82050084
#define SE_ECC_ERROR_SKF_CLOSE_APP								0x82050085

#define SE_ECC_ERROR_FUNC_LOCAL									0x82058000 //ںڲԶ


//HASH_SIGN_ALGORITHM
#define SE_ALG_sha1WithRSAEncryption     "1.2.840.113549.1.1.5"
#define SE_ALG_sha224WithRSAEncryption   "1.2.840.113549.1.1.14"
#define SE_ALG_sha256WithRSAEncryption   "1.2.840.113549.1.1.11"
#define SE_ALG_sha384WithRSAEncryption   "1.2.840.113549.1.1.12"
#define SE_ALG_sha512WithRSAEncryption   "1.2.840.113549.1.1.13"
#define SE_ALG_md2WithRSAEncryption      "1.2.840.113549.1.1.2"
#define SE_ALG_md4WithRSAEncryption      "1.2.840.113549.1.1.3"
#define SE_ALG_md5WithRSAEncryption      "1.2.840.113549.1.1.4"
#define SE_ALG_ecdsaWithSHA1             "1.2.840.10045.4.1"
#define SE_ALG_ecdsaWithSHA224           "1.2.840.10045.4.3.1"
#define SE_ALG_ecdsaWithSHA256           "1.2.840.10045.4.3.2"
#define SE_ALG_ecdsaWithSHA384           "1.2.840.10045.4.3.3"
#define SE_ALG_ecdsaWithSHA512           "1.2.840.10045.4.3.4"

#define SE_ALG_ecsm2WithSM3		         "1.2.156.10197.1.501"     //<<--
#define SE_ALG_ecwapiWithSHA256          "1.2.156.11235.1.1.1"

//public key encryption:
#define SE_ALG_ecSM2_3Encryption			"1.2.156.10197.1.301.3"

//SYMMETRIC_ALGORITHM
#define SE_ALG_rc2                       "1.2.840.113549.3.3"
#define SE_ALG_rc4                       "1.2.840.113549.3.4"
#define SE_ALG_rc5                       "1.2.840.113549.3.8"
#define SE_ALG_idea                      "1.3.6.1.4.1.188.7.1.1.1"
#define SE_ALG_des                       "1.3.14.3.2.6"
#define SE_ALG_tripleDES                 "1.2.840.113549.3.7"
#define SE_ALG_aes                       "2.16.840.1.101.3.4.1.1"
#define SE_ALG_scb2                      "scb2"
#define SE_ALG_sdbi                      "sdbi"
#define SE_ALG_ssf33                     "1.2.156.10197.1.103"
#define SE_ALG_sm1						 "1.2.156.10197.1.102"
#define SE_ALG_sm3                       "1.2.156.10197.1.401.1"
#define SGD_SMS4_ECB					 0x00000401
#define SGD_SDBI_CRYPTY					 0x00000501

//HASH_ALGORITHM
#define SE_ALG_sha1                      "1.3.14.3.2.26"
#define SE_ALG_sha224                    "2.16.840.1.101.3.4.2.4"
#define SE_ALG_sha256                    "2.16.840.1.101.3.4.2.1"
#define SE_ALG_sha384                    "2.16.840.1.101.3.4.2.2"
#define SE_ALG_sha512                    "2.16.840.1.101.3.4.2.3"
#define SE_ALG_md2                       "1.2.840.113549.2.2"
#define SE_ALG_md4                       "1.2.840.113549.2.4"
#define SE_ALG_md5                       "1.2.840.113549.2.5"

#define OBJ_ALG_sm3                      "1.2.156.10197.1.401.1"   //<<--

//NAMED ELLIPTICAL CURVES
#define SE_EC_prime192v1                 "1.2.840.10045.3.1.1"
#define SE_EC_prime192v2                 "1.2.840.10045.3.1.2"
#define SE_EC_prime192v3                 "1.2.840.10045.3.1.3"
#define SE_EC_prime239v1                 "1.2.840.10045.3.1.4"
#define SE_EC_prime239v2                 "1.2.840.10045.3.1.5"
#define SE_EC_prime239v3                 "1.2.840.10045.3.1.6"
#define SE_EC_prime256v1                 "1.2.840.10045.3.1.7"

#define SE_EC_secp112r1                  "1.3.132.0.6"
#define SE_EC_secp112r2                  "1.3.132.0.7"
#define SE_EC_secp128r1                  "1.3.132.0.28"
#define SE_EC_secp128r2                  "1.3.132.0.29"
#define SE_EC_secp160k1                  "1.3.132.0.9"
#define SE_EC_secp160r1                  "1.3.132.0.8"
#define SE_EC_secp160r2                  "1.3.132.0.30"
#define SE_EC_secp192k1                  "1.3.132.0.31"
#define SE_EC_secp192r1                  "1.2.840.10045.3.1.1"
#define SE_EC_secp224k1                  "1.3.132.0.32"
#define SE_EC_secp224r1                  "1.3.132.0.33"
#define SE_EC_secp256k1                  "1.3.132.0.10"
#define SE_EC_secp256r1                  "1.2.840.10045.3.1.7"
#define SE_EC_secp384r1                  "1.3.132.0.34"
#define SE_EC_secp521r1                  "1.3.132.0.35"
#define SE_EC_sect113r1                  "1.3.132.0.4"
#define SE_EC_sect113r2                  "1.3.132.0.5"
#define SE_EC_sect131r1                  "1.3.132.0.22"
#define SE_EC_sect131r2                  "1.3.132.0.23"
#define SE_EC_sect163k1                  "1.3.132.0.1"
#define SE_EC_sect163r1                  "1.3.132.0.2"
#define SE_EC_sect163r2                  "1.3.132.0.15"
#define SE_EC_sect193r1                  "1.3.132.0.24"
#define SE_EC_sect193r2                  "1.3.132.0.25"
#define SE_EC_sect233k1                  "1.3.132.0.26"
#define SE_EC_sect233r1                  "1.3.132.0.27"
#define SE_EC_sect239k1                  "1.3.132.0.3"
#define SE_EC_sect283k1                  "1.3.132.0.16"
#define SE_EC_sect283r1                  "1.3.132.0.17"
#define SE_EC_sect409k1                  "1.3.132.0.36"
#define SE_EC_sect409r1                  "1.3.132.0.37"
#define SE_EC_sect571k1                  "1.3.132.0.38"
#define SE_EC_sect571r1                  "1.3.132.0.39"

#define SE_EC_nistp192                   "1.2.840.10045.3.1.1"
#define SE_EC_nistp224                   "1.3.132.0.33"
#define SE_EC_nistp256                   "1.2.840.10045.3.1.7"
#define SE_EC_nistp384                   "1.3.132.0.34"
#define SE_EC_nistp521                   "1.3.132.0.35"
#define SE_EC_nistk163                   "1.3.132.0.1"
#define SE_EC_nistb163                   "1.3.132.0.2"
#define SE_EC_nistk233                   "1.3.132.0.26"
#define SE_EC_nistb233                   "1.3.132.0.27"
#define SE_EC_nistk283                   "1.3.132.0.16"
#define SE_EC_nistb283                   "1.3.132.0.17"
#define SE_EC_nistk409                   "1.3.132.0.36"
#define SE_EC_nistb409                   "1.3.132.0.37"
#define SE_EC_nistk571                   "1.3.132.0.38"
#define SE_EC_nistb571                   "1.3.132.0.39"

#define SE_EC_sm2                        "1.2.156.10197.1.301"    //<<--
#define SE_EC_wapi                       "1.2.156.11235.1.1.2.1"

//X500 name string type
/*X500 Name String Type*/
#define ISSUER_NAME_TELETEX            0x01
#define ISSUER_NAME_PRINTABLE          0x02
#define ISSUER_NAME_UNIVERSAL          0x03
#define ISSUER_NAME_UTF8               0x04
#define ISSUER_NAME_BMP                0x05
#define ISSUER_NAME_MASK               0x0F
#define SUBJECT_NAME_TELETEX           0x10
#define SUBJECT_NAME_PRINTABLE         0x20
#define SUBJECT_NAME_UNIVERSAL         0x30
#define SUBJECT_NAME_UTF8              0x40
#define SUBJECT_NAME_BMP               0x50
#define SUBJECT_NAME_MASK              0xF0

#define MAX_CERTCHAIN_LENGTH			4096

#define MAX_X500_NAME_LEN                256
#define MAX_DIGEST_LEN					 128
#define MAX_PRIVKEY_LENGTH				 128

#define MAX_SERIAL_LEN                 128
#define MAX_ALGO_PARA_LEN              1024
#define MAX_UNIQUE_ID_LEN              128
#define MAX_PUBLIC_KEY_LEN             1024
#define MAX_SIGNATURE_LEN              512

#define MAX_UNKNOWN_EXT                8
#define MAX_OID_SIZE                   32 
#define MAX_EXT_VAL_SIZE               1024

#define MAX_P7_SIGN_LENGTH			2048

#define CERTTYPE_SIGN		0
#define CERTTYPE_ENCRYPT	1

#ifdef _WINDOWS
#define SAFEENGINE_DLL_NAME "ecc_se.dll"
#define READCERT_DLL_NAME "ecc_readcert.dll"
#else
#define SAFEENGINE_DLL_NAME "libecc_se.so"
#define READCERT_DLL_NAME "libecc_readcert.so"
#endif

//PKCS#10 information
typedef struct{
	int   version;
	char  subject_countryName[MAX_X500_NAME_LEN];
	char  subject_organizationName[MAX_X500_NAME_LEN];
	char  subject_organizationalUnitname1[MAX_X500_NAME_LEN];
	char  subject_stateOrProvinceName[MAX_X500_NAME_LEN];
	char  subject_commonName[MAX_X500_NAME_LEN];
	char  subject_localityName[MAX_X500_NAME_LEN];
	char  subject_title[MAX_X500_NAME_LEN];
	char  subject_surname[MAX_X500_NAME_LEN];
	char  subject_givenName[MAX_X500_NAME_LEN];
	char  subject_initials[MAX_X500_NAME_LEN];
	char  subject_email[MAX_X500_NAME_LEN];
	char  subject_postalAddress[MAX_X500_NAME_LEN];
	char  subject_postalCode[MAX_X500_NAME_LEN];
	char  subject_postalOfficeBox[MAX_X500_NAME_LEN];
	char  subject_telephoneNumber[MAX_X500_NAME_LEN];
	char  subject_telexNumber[MAX_X500_NAME_LEN];
	unsigned char  subjectPublicKeyInfo[MAX_PUBLIC_KEY_LEN];
	int   subjectPublicKeyInfoSize;
} PKCS10_INFO;

//KEY_INFO
#define MAX_ECC_KEY_LENGTH                128
#define MAX_OID_LENGTH                    128

enum KEY_TYPE
{
	EccPublicKey,
	EccPrivateKey
};

typedef struct{
	unsigned char pubx[MAX_ECC_KEY_LENGTH];
	int pubxbyte;
	unsigned char puby[MAX_ECC_KEY_LENGTH];
	int pubybyte;
	
}ECC_PUB_KEY;

typedef struct{
	unsigned char pubx[MAX_ECC_KEY_LENGTH];
	int pubxbyte;
	unsigned char puby[MAX_ECC_KEY_LENGTH];
	int pubybyte;
	unsigned char prikey[MAX_ECC_KEY_LENGTH];
	int prikeybyte;

}ECC_PRI_KEY;


typedef struct {
    char oid[MAX_OID_LENGTH];
	int oidbyte;
    int version;
	enum KEY_TYPE type;
	union{
		ECC_PUB_KEY  eccpubkeyinfo;
		ECC_PRI_KEY  eccprikeyinfo;
	}keyinfo;
}KEY_INFO;

//HSE handle
typedef void* HSE;

typedef unsigned long long uint64;
typedef unsigned long   uint32;
typedef unsigned short	uint16;
typedef unsigned char	uint8;
 
typedef  unsigned long APICONTEXT;

typedef struct SERIAL_INFO_{
    uint8              serialNumber[MAX_SERIAL_LEN];
    uint16             serialNumberLen;
} SERIAL_INFO;

typedef struct ALGORITHM_INFO_{
    uint16             algorithm;
    uint8              parameters[MAX_PUBLIC_KEY_LEN];
    uint16             parametersLen;
} ALGORITHM_INFO;

typedef  struct X500_NAME_INFO_{
    char               countryName[MAX_X500_NAME_LEN];
    char               organizationName[MAX_X500_NAME_LEN];
    char               organizationalUnitname[MAX_X500_NAME_LEN];
    char               stateOrProvinceName[MAX_X500_NAME_LEN];
    char               commonName[MAX_X500_NAME_LEN];
    char               localityName[MAX_X500_NAME_LEN];
    char               title[MAX_X500_NAME_LEN];
    char               surname[MAX_X500_NAME_LEN];
    char               givenName[MAX_X500_NAME_LEN];
    char               initials[MAX_X500_NAME_LEN];
    char               email[MAX_X500_NAME_LEN];
    char               postalAddress[MAX_X500_NAME_LEN];
    char               postalCode[MAX_X500_NAME_LEN];
    char               postalOfficeBox[MAX_X500_NAME_LEN];  /**/
    char               telephoneNumber[MAX_X500_NAME_LEN];
    char               telexNumber[MAX_X500_NAME_LEN];      
} X500_NAME_INFO;


typedef struct PUBLIC_KEY_INFO_{
    uint8              derPublicKey[MAX_ALGO_PARA_LEN];
    uint16             derPublicKeyLen;
    ALGORITHM_INFO     algorithmInfo;
} PUBLIC_KEY_INFO;

typedef struct UNIQUE_ID_INFO_{
    uint8              uniqueID[MAX_UNIQUE_ID_LEN];
    uint16             uniqueIDLen;
} UNIQUE_ID_INFO;

typedef struct CA_SIGNATURE_INFO_{
	uint8              caSignature[MAX_SIGNATURE_LEN];
	uint16             caSignatureLen;
} CA_SIGNATURE_INFO;

typedef struct{
    X500_NAME_INFO             directoryName;
    SERIAL_INFO                serialNumber;
} USER_AuthKeyIdentifier_INFO;

typedef struct{
    char        notBefore[64];   /*YYYYMMDDHHMMSS*/
    char        notAfter[64];    /*YYYYMMDDHHMMSS*/
} USER_PrivateKeyUsagePeriod_INFO;

typedef struct{
    uint8       policyIdentifier[4][32];
    uint32      policyIdentifierSize[4];
    char        CPS_url[4][MAX_X500_NAME_LEN];
} USER_CertificatePolicies_INFO;

typedef struct{
    uint8       cA;
    uint32      pathLenConstraint;
} USER_BasicConstraints_INFO;

typedef struct{
    uint32      keyUsage_bit;
} USER_KeyUsage_INFO;

typedef struct{
    uint32      neCertType_bit;
} USER_neCertType_INFO;

typedef struct{
   uint32      setCertType_bit;
} USER_setCertType_INFO;

typedef struct{
    uint8       hashedRootKey[64];
    uint32      hashedRootKeySize;
} USER_setHashedRootKey_INFO;

typedef struct{
    uint8       oid[MAX_UNKNOWN_EXT][MAX_OID_SIZE];
    uint32      oidSize[MAX_UNKNOWN_EXT];
    uint8       critical[MAX_UNKNOWN_EXT];
    uint8       value[MAX_UNKNOWN_EXT][MAX_EXT_VAL_SIZE]; 
    uint32      valueSize[MAX_UNKNOWN_EXT];
    uint32      extSize; 
} USER_privateExt_INFO;

typedef struct{
    USER_AuthKeyIdentifier_INFO       AuthKeyIdentifier;
    USER_CertificatePolicies_INFO     CertificatePolicies;
    USER_PrivateKeyUsagePeriod_INFO   PrivateKeyUsagePeriod;
    USER_BasicConstraints_INFO        BasicConstraints;
    USER_KeyUsage_INFO                KeyUsage;
    USER_neCertType_INFO              neCertType;
    USER_setCertType_INFO             setCertType;
    USER_setHashedRootKey_INFO        setHashedRootKey;
    uint32                            selfCertClass;
    char                              revocationURL[MAX_X500_NAME_LEN];
    USER_privateExt_INFO              privateExt;
} USER_EXTENSION_INFO;

typedef struct{
    uint8                 version;
    SERIAL_INFO           serialNumber;
    ALGORITHM_INFO        signature;
    X500_NAME_INFO        issuer;
    char                  notBefore[64];   /*YYYYMMDDHHMMSS*/
    char                  notAfter[64];    /*YYYYMMDDHHMMSS*/
    X500_NAME_INFO        subject;
    PUBLIC_KEY_INFO       subjectPublicKeyInfo;
    UNIQUE_ID_INFO        issuerUniqueID; 
    UNIQUE_ID_INFO        subjectUniqueID;
    CA_SIGNATURE_INFO     caSignature;

    uint32                extensionsFlag;
    uint32                criticalFlag;

    USER_EXTENSION_INFO   extensions;

} CERT_INFO_EX;

#define MAX_SN_LEN			256
#define MAX_DEV_NAME_LEN	256
#define	MAX_PATH			260

#define KEY_ALG_RSA			1
#define KEY_ALG_ECC			2
#define KEY_ALG_RSA_AND_ECC 3

typedef struct DEVICE_INFO_
{
	long devType;
	int alg;
	char devName[MAX_DEV_NAME_LEN];
	char devParam[MAX_PATH+1];
	char sn[MAX_SN_LEN];
}DEVICE_INFO;

typedef struct DEVICE_LIST_
{
	int num;
	DEVICE_INFO devices[1];
}DEVICE_LIST;


//Function definition
#ifdef __cplusplus
extern "C" {
#endif  

#ifdef __cplusplus
}
#endif    

#endif